type position = (int * int)

class type piece =
    object
        method x : int
        method y : int
        method move_to : position -> unit
        method can_capture : piece -> bool
        method to_s : string
    end

class virtual piece_base :
    position ->
    object
        method x : int
        method y : int
        method move_to : position -> unit
        method virtual can_capture : piece -> bool
        method virtual to_s : string
    end

class queen : position -> piece

class board :
    int -> (int -> piece) ->
    object
        method size : int
        method pieces : piece list
        method get : position -> piece option
        method to_s : string
    end

